require 'gun_test/shell'

module GunTest
  class Shot
    include Shell

    def initialize
      @bullet = nil
      @target = nil
    end

    def bullet(bullet = nil)
      @bullet = bullet
      @bullet ||= yield if block_given?
    end

    def target(target = nil)
      @target = target
      @target ||= yield if block_given?
    end

    def bang!(gun)
      cmd = (gun[0] == '/' ? '' : './') + gun

      IO.popen(cmd, "r+") do |io|
        io.puts @bullet
        io.close_write

        @target == io.gets(nil)
      end
    end
  end
end
